#include "app.h"

static void TSKsysinfExit(TSK *tskp);
static void TSKsysinfDraw(TSK *tskp);
static void TSKscoreExit(TSK *tskp);
static void TSKscoreDraw(TSK *tskp);
static void TSKzoneExit(TSK *tskp);
static void TSKzoneDraw(TSK *tskp);
static void TSKgameoverExit(TSK *tskp);
static void TSKgameoverDraw(TSK *tskp);
static void TSKcleartimeExit(TSK *tskp);
static void TSKcleartimeDraw(TSK *tskp);
static void TSKattractExit(TSK *tskp);
static void TSKattractDraw(TSK *tskp);

static fixed stg_time;
static fixed ply_time;
static fixed avg_time;
static fixed bns_time;
static fixed stg_time_add;
static fixed ply_time_add;
static fixed avg_time_add;
static fixed bns_time_add;

static VERTEX vertex[] = {
							{ fld(+0.0), fld(-8.0) },
							{ fld(-8.0), fld(+8.0) },
							{ fld(+0.0), fld(+1.0) },
							{ fld(+8.0), fld(+8.0) },
						};

void TSKsysinf(TSK *tskp)
{
	switch(tskp->step){
		case	0:
			tskp->exit_adr = &TSKsysinfExit;
			tskp->draw_adr = &TSKsysinfDraw;
			setGRPlineObj(tskp, vertex, ARRAY_SIZE(vertex));
			TSKpalleteSet(tskp, 128, 128, 255, 255);
			tskp->cnt = 0;
			tskp->step++;
			break;
		case	1:
			tskp->cnt++;
			break;
		default:
			TSKclear(tskp);
			break;
	}
}

static void TSKsysinfExit(TSK *tskp)
{
}

static void TSKsysinfDraw(TSK *tskp)
{
	char str[256];
	int time, s, ms;
	int i;
	fixed x, y;

	sprintf(str, "SCORE %d", score);
	x = fadd(fild(80), fidiv(ASC_SIZE_X, 2));
	y = fild(18 + 4/**/);
	drawASCII(str, x, y);

	if(attract_mode == 0){
		x = fild(560 - 16);
		y = fild(18 + 4/**/);
		for(i = 0; i < left; i++){
			tskp->pos[X] = x;
			tskp->pos[Y] = y;
			drawGRPlineObjAbs(tskp);
			fisub_(x, 18);
		}
	}

	sprintf(str, "ENEMY %d", enemy_cnt - enemy_dest);
	x = fadd(fild(80), fidiv(ASC_SIZE_X, 2));
	y = fild(466);
	drawASCII(str, x, y);

	if(limit_time){
		time = limit_time;
		s  = time / 60;
		ms = ((time % 60) * 100 / 60);
		sprintf(str, "TIME %02d:%02d", s, ms);
		x = fsub(fild(560 + 10/**/), getWidthASCII(str));
	}else{
		if(!(tskp->cnt & 0x20)) strcpy(str, "CONDITION:ALERT!");
		else					strcpy(str, "");
		x = fsub(fild(560 + 10/**/), getWidthASCII(str));
	}
	y = fild(466);
	drawASCII(str, x, y);
}

void TSKscore(TSK *tskp)
{
	switch(tskp->step){
		case	0:
			tskp->exit_adr = &TSKscoreExit;
			tskp->draw_adr = &TSKscoreDraw;
			tskp->wait = 60;
			tskp->step++;
			break;
		case	1:
			if(tskp->wait){
				tskp->wait--;
			}else{
				tskp->step = -1;
			}
			break;
		default:
			TSKclear(tskp);
			break;
	}
}

static void TSKscoreExit(TSK *tskp)
{
}

static void TSKscoreDraw(TSK *tskp)
{
	char str[256];
	fixed x, y;

	sprintf(str, "%d", tskp->cnt);
	x = fadd(fsub(tskp->pos[X], fidiv(getWidthASCII(str), 2)), fidiv(ASC_SIZE_X, 2));
	y = tskp->pos[Y];
	drawASCII(str, x, y);
}

void TSKzone(TSK *tskp)
{
	switch(tskp->step){
		case	0:
			tskp->exit_adr = &TSKzoneExit;
			tskp->draw_adr = &TSKzoneDraw;
			tskp->wait = 90;
			tskp->step++;
			break;
		case	1:
			if(tskp->wait){
				tskp->wait--;
			}else{
				tskp->step = -1;
			}
			break;
		default:
			TSKclear(tskp);
			break;
	}
}

static void TSKzoneExit(TSK *tskp)
{
}

static void TSKzoneDraw(TSK *tskp)
{
	char str[256];
	fixed x, y;

	sprintf(str, "ZONE %d", stage + 1);
	x = fadd(fsub(fild(320), fidiv(getWidthASCII(str), 2)), fidiv(ASC_SIZE_X, 2));
	y = fild(232);
	drawASCII(str, x, y);
}

void TSKgameover(TSK *tskp)
{
	switch(tskp->step){
		case	0:
			tskp->exit_adr = &TSKgameoverExit;
			tskp->draw_adr = &TSKgameoverDraw;
			tskp->wait = 180;
			tskp->step++;
			break;
		case	1:
			if(tskp->wait){
				tskp->wait--;
			}else{
				tskp->step = -1;
			}
			break;
		default:
			TSKclear(tskp);
			break;
	}
}

static void TSKgameoverExit(TSK *tskp)
{
}

static void TSKgameoverDraw(TSK *tskp)
{
	char str[256];
	fixed x, y;

	strcpy(str, "GAME OVER");
	x = fadd(fsub(fild(320), fidiv(getWidthASCII(str), 2)), fidiv(ASC_SIZE_X, 2));
	y = fild(232);
	drawASCII(str, x, y);
}

void TSKcleartime(TSK *tskp)
{
	switch(tskp->step){
		case	0:
			tskp->exit_adr = &TSKcleartimeExit;
			tskp->draw_adr = &TSKcleartimeDraw;
			stg_time = 0;
			ply_time = 0;
			avg_time = 0;
			bns_time = 0;
			stg_time_add = fidiv(      fild(stagetime )           , 30);
			ply_time_add = fidiv(      fild(playtime  )           , 30);
			avg_time_add = fidiv(fidiv(fild(playtime  ), play_stg), 30);
			bns_time_add = fidiv(      fild(time_bonus)           , 30);
			tskp->wait = 75;
			tskp->step++;
			break;
		case	1:
			if(tskp->wait > 45){
				fadd_(stg_time, stg_time_add);
				fadd_(ply_time, ply_time_add);
				fadd_(avg_time, avg_time_add);
				fadd_(bns_time, bns_time_add);
				fadd_(tskp->pos[Y], tskp->vel[Y]);
				tskp->wait--;
			}else{
				stg_time =       fild(stagetime )           ;
				ply_time =       fild(playtime  )           ;
				avg_time = fidiv(fild(playtime  ), play_stg);
				bns_time =       fild(time_bonus)           ;
				addScore(time_bonus);
				tskp->step++;
			}
			break;
		case	2:
			if(tskp->wait){
				tskp->wait--;
			}else{
				tskp->step = -1;
			}
			break;
		default:
			TSKclear(tskp);
			break;
	}
}

static void TSKcleartimeExit(TSK *tskp)
{
}

static void TSKcleartimeDraw(TSK *tskp)
{
	char str[256];
	int time, h, m, s, ms;
	fixed x, y, len;

	strcpy(str, "AVARAGE TIME 00:00:00:00");
	len = getWidthASCII(str);

	if(stagetime < skip_stage){
		dispSDLmask(fild(320), fild(240), fadd(len, ASC_SIZE_X), fiadd(fimul(ASC_SIZE_Y, 5), 8), 2);
		y = fadd(fsub(fild(240), fidiv(fimul(ASC_SIZE_Y, 5), 2)), fidiv(ASC_SIZE_Y, 2));
	}else{
		dispSDLmask(fild(320), fild(240), fadd(len, ASC_SIZE_X), fiadd(fimul(ASC_SIZE_Y, 4), 8), 2);
		y = fadd(fsub(fild(240), fidiv(fimul(ASC_SIZE_Y, 4), 2)), fidiv(ASC_SIZE_Y, 2));
	}

	time = fist(stg_time);
	h  = time / (60 * 60 * 60);
	m  = time / (60 * 60     ) % 60;
	s  = time / (60          ) % 60;
	ms = ((time % 60) * 100 / 60);
	sprintf(str, "  STAGE TIME %02d:%02d:%02d:%02d", h, m, s, ms);
	x = fadd(fsub(fild(320), fidiv(len, 2)), fidiv(ASC_SIZE_X, 2));
	drawASCII(str, x, y);
	fadd_(y, ASC_SIZE_Y);

	time = fist(ply_time);
	h  = time / (60 * 60 * 60);
	m  = time / (60 * 60     ) % 60;
	s  = time / (60          ) % 60;
	ms = ((time % 60) * 100 / 60);
	sprintf(str, "  TOTAL TIME %02d:%02d:%02d:%02d", h, m, s, ms);
	x = fadd(fsub(fild(320), fidiv(len, 2)), fidiv(ASC_SIZE_X, 2));
	drawASCII(str, x, y);
	fadd_(y, ASC_SIZE_Y);

	time = fist(avg_time);
	h  = time / (60 * 60 * 60);
	m  = time / (60 * 60) % 60;
	s  = time / 60 % 60;
	ms = ((time % 60) * 100 / 60);
	sprintf(str, "AVARAGE TIME %02d:%02d:%02d:%02d", h, m, s, ms);
	x = fadd(fsub(fild(320), fidiv(len, 2)), fidiv(ASC_SIZE_X, 2));
	drawASCII(str, x, y);
	fadd_(y, ASC_SIZE_Y);

	h = fist(bns_time);
	sprintf(str, "  TIME BONUS %06d", h);
	x = fadd(fsub(fild(320), fidiv(len, 2)), fidiv(ASC_SIZE_X, 2));
	drawASCII(str, x, y);
	fadd_(y, ASC_SIZE_Y);

	if(stagetime < skip_stage){
		if(stagetime < skip_stage_3) strcpy(str, "3 ZONE SKIP!");
		else                         strcpy(str, "2 ZONE SKIP!");
		x = fsub(fild(320), fidiv(getWidthASCII(str), 2));
		drawASCII(str, x, y);
	}
}

void TSKattract(TSK *tskp)
{
	switch(tskp->step){
		case	0:
			tskp->exit_adr = &TSKattractExit;
			tskp->draw_adr = &TSKattractDraw;
			tskp->cnt = 0;
			tskp->step++;
			break;
		case	1:
			tskp->cnt++;
			break;
		default:
			TSKclear(tskp);
			break;
	}
}

static void TSKattractExit(TSK *tskp)
{
}

static void TSKattractDraw(TSK *tskp)
{
	char str[256];
	fixed x, y;

	y = fild(272);

	if(tskp->cnt & 0x20){
		if(!(tskp->cnt & 0x40)){
			x = fadd(fsub(fild(320), fidiv(getWidthASCII("DEMO PLAY"), 2)), fidiv(ASC_SIZE_X, 2));
			drawASCII("DEMO PLAY", x, y);
		}else{
			if(SDL_PCB_CoinGetCredit()){
				x = fadd(fsub(fild(320), fidiv(getWidthASCII("INSERT COIN"), 2)), fidiv(ASC_SIZE_X, 2));
				drawASCII("INSERT COIN", x, y);
			}else{
				x = fadd(fsub(fild(320), fidiv(getWidthASCII("PRESS SHOT BUTTON"), 2)), fidiv(ASC_SIZE_X, 2));
				drawASCII("PRESS SHOT BUTTON", x, y);
			}
		}
	}

	if(SDL_PCB_CoinGetChute()){
		if(SDL_PCB_CoinGetCredit() == 1){
			sprintf(str, "CREDIT %d", SDL_PCB_CoinGetOneCredit());
		}else if(SDL_PCB_CoinGetCredit() > 1){
			sprintf(str, "CREDIT %d/%d", SDL_PCB_CoinGetOneCredit(), (SDL_PCB_CoinGetChute() % SDL_PCB_CoinGetCredit()));
		}
		x = fadd(fsub(fild(320), fidiv(getWidthASCII(str), 2)), fidiv(ASC_SIZE_X, 2));
		y = fild(460);
		drawASCII(str, x, y);
	}
}

