#include "app.h"

#define PAL_R 240
#define PAL_G 160
#define PAL_B 160
#define ROLL_RATE fld(0.035)

static void TSKzako01Int(TSK *tskp);
static void TSKzako01Exit(TSK *tskp);
static void TSKzako01Draw(TSK *tskp);
static void TSKzako01SetForm(TSK *tskp);
static int TSKzako01ShotCtrl(TSK *tskp);

static VERTEX ver_org[] = {
							{ fld( +0.0), fld(-16.0) },
							{ fld(+13.0), fld( +7.0) },
							{ fld(-13.0), fld( +7.0) },
						};

static PAL32 color;

void TSKzako01(TSK *tskp)
{
	switch(tskp->step){
		case	0:
			tskp->tskid |= TSKID_ENEMY;
			tskp->int_adr = NULL;
			tskp->exit_adr = &TSKzako01Exit;
			tskp->draw_adr = &TSKzako01Draw;
			TSKzako01SetForm(tskp);
			TSKenemyPosSet(tskp);
			tskp->col[X] = fild(12);
			tskp->col[Y] = fild(12);
			tskp->roll = 0;
			tskp->cnt = 0;
			tskp->score = 100;
			TSKpalleteSet(tskp, 0, 0, 0, 255);
			SDL_PCB_SndPlaySe(SND_ENEMY);
			tskp->step++;
			break;
		case	1:
			if(!tskp->cnt){
				tskp->cnt = 2 + rand() % 4;
			}
			tskp->wait = 120 - isTimeUp() * 90;
			fadd_(tskp->roll, ROLL_RATE);
			tskp->step++;
			break;
		case	2:
			if(tskp->wait){
				if(tskp->int_adr == NULL){
					if(tskp->color.r < PAL_R) tskp->color.r += 8;
					else					  tskp->color.r  = PAL_R;
					if(tskp->color.g < PAL_G) tskp->color.g += 8;
					else					  tskp->color.g  = PAL_G;
					if(tskp->color.b < PAL_B) tskp->color.b += 8;
					else					  tskp->color.b  = PAL_B;
					TSKpalleteSet(tskp, tskp->color.r, tskp->color.g, tskp->color.b, 255);
					if(tskp->color.r == PAL_R) tskp->int_adr = &TSKzako01Int;
				}else{
					if(tskp->wait < 30){
						color.r = rand() % 255;
						color.g = rand() % 255;
						color.b = rand() % 255;
						TSKpalleteSet(tskp, color.r, color.g, color.b, 255);
					}
				}
				tskp->wait--;
			}else{
				TSKpalleteSet(tskp, PAL_R, PAL_G, PAL_B, 255);
				if(TSKzako01ShotCtrl(tskp)){
					tskp->cnt--;
					if(tskp->cnt){
						tskp->step = 1;
					}else{
						tskp->wait = 15;
						tskp->step++;
					}
				}
			}
			fadd_(tskp->roll, ROLL_RATE);
			break;
		case	3:
			if(tskp->wait){
				tskp->wait--;
			}else{
				tskp->step++;
			}
			fadd_(tskp->roll, ROLL_RATE);
			break;
		case	4:
			if((rand() % 100) > 50){
				if((rand() % 100) > 50){
					tskp->vel[X] = fld(-32.0 / 15.0);
					tskp->vel[Y] = 0;
				}else{
					tskp->vel[X] = fld(+32.0 / 15.0);
					tskp->vel[Y] = 0;
				}
			}else{
				if((rand() % 100) > 50){
					tskp->vel[X] = 0;
					tskp->vel[Y] = fld(-32.0 / 15.0);
				}else{
					tskp->vel[X] = 0;
					tskp->vel[Y] = fld(+32.0 / 15.0);
				}
			}
			fadd_(tskp->roll, ROLL_RATE);
			tskp->wait = 15;
			tskp->step++;
			break;
		case	5:
			if(tskp->wait){
				tskp->wait--;
				fadd_(tskp->pos[X], tskp->vel[X]);
				fadd_(tskp->pos[Y], tskp->vel[Y]);
			}else{
				tskp->step = 1;
			}
			TSKareaClamp(tskp);
			fadd_(tskp->roll, ROLL_RATE);
			break;
		case	100:
			TSKpalleteSet(tskp, PAL_R, PAL_G, PAL_B, 255);
			SDL_PCB_SndPlaySe(SND_EDEST);
			enemy_destroy(tskp);
			setTSKbroken(tskp, 8, fild(4));
			color.r = 255;
			color.g = 255;
			color.b = 0;
			color.a = 255;
			setTSKparticle(tskp, 8, fild(8), color);
			tskp->step = -1;
			break;

		default:
			TSKclear(tskp);
			break;
	}
}

static void TSKzako01Int(TSK *tskp)
{
	if(tskp->tsk_collision->tskid & TSKID_SHIP) return;
	tskp->int_adr = NULL;
	tskp->score *= tskp->tsk_collision->level + 1;
	tskp->step = 100;
}

static void TSKzako01Exit(TSK *tskp)
{
}

static void TSKzako01Draw(TSK *tskp)
{
	drawGRPlineObj(tskp);
}

static void TSKzako01SetForm(TSK *tskp)
{
	setGRPlineObj(tskp, ver_org, ARRAY_SIZE(ver_org));
}

static int TSKzako01ShotCtrl(TSK *tskp)
{
	TSK *etskp;
	int dir;
	fixed ofs_x, ofs_y;

	if(ficom(getShipDist(tskp), <, 32)) return 0;

	if(tsk_ship){
		ofs_x = fsub(tsk_ship->pos[X], tskp->pos[X]);
		ofs_y = fsub(tsk_ship->pos[Y], tskp->pos[Y]);
	}else{
		ofs_x = fild(rand() % 10);
		ofs_y = fild(rand() % 10);
	}

	if(fcom(ffabs(ofs_x), >, ffabs(ofs_y))){
		if(ficom(ofs_x, >, 0)) dir = PAD_RI;
		else				   dir = PAD_LF;
	}else{
		if(ficom(ofs_y, >, 0)) dir = PAD_DN;
		else				   dir = PAD_UP;
	}

	etskp = TSKsetBtm(&TSKeshot, GROUP_ESHOT);
	if(etskp){
		etskp->pos[X] = tskp->pos[X];
		etskp->pos[Y] = tskp->pos[Y];
		etskp->len = ESHOT_LENGTH;
		switch(dir){
			case	PAD_RI:
				etskp->vel[X] = fiadd(     ESHOT_SPD , isTimeUp() * 2);
				etskp->vel[Y] = 0;
				etskp->roll = PI_2;
				break;
			case	PAD_LF:
				etskp->vel[X] = fisub(fchs(ESHOT_SPD), isTimeUp() * 2);
				etskp->vel[Y] = 0;
				etskp->roll = fchs(PI_2);
				break;
			case	PAD_DN:
				etskp->vel[X] = 0;
				etskp->vel[Y] = fiadd(     ESHOT_SPD , isTimeUp() * 2);
				etskp->roll = PI;
				break;
			case	PAD_UP:
				etskp->vel[X] = 0;
				etskp->vel[Y] = fisub(fchs(ESHOT_SPD), isTimeUp() * 2);
				etskp->roll = 0;
				break;
		}
		TSKareaClamp(etskp);
	}

	return 1;
}
